<%@ Page Language="vb" Strict="True"  %>
<%@ Import Namespace="system.io" %>
<%@ Import Namespace="System.Drawing" %> 
<script language="vb" runat="server">

  '******************************************************************
  '*  IDAutomation Native GS1DataBarExpanded ASPX Barcode Generator 2019
  '*  Copyright, IDAutomation.com, Inc. All rights reserved.
  '******************************************************************
  '*  DEMO VERSION NOTICE:
  '*  The demo version of this product contains a static barcode that may be
  '*  used for evaluation purposes only. The static barcode cannot be
  '*  changed because this would reveal the complete formula, which is only
  '*  available in the purchased version. The purchased version is provided 
  '*  with a money back satisfaction guarantee. If it is necessary to 
  '*  test dynamic barcodes with this product, the purchased version is required.
  '*  http://www.idautomation.com/barcode-components/aspx-generator-script/#licensing
  '******************************************************************
  '*  Redistribution and use of this code in source and/or binary
  '*  forms, with or without modification, are permitted provided
  '*  that: (1) all copies of the source code retain the above
  '*  unmodified copyright notice and this entire unmodified
  '*  section of text, (2) You or Your organization owns a valid
  '*  Developer License to this product from IDAutomation.com
  '*  and, (3) when any portion of this code is bundled in any
  '*  form with an application, A valid notice must be provided
  '*  within the user documentation, start-up screen or in the
  '*  help-about section of the application that specifies
  '*  IDAutomation.com as the provider of the Software bundled
  '*  with the application.
  '******************************************************************

  '' URL params
  '' ----------
  '' D    (string)   data to encode (Cannot be changed in the Demo version)
  '' H    (integer)  height, default 34, range [2 .. 99] (Cannot be changed in the Demo version)
  '' X    (integer)  zoom factor, default 1, range [1 .. n] (Cannot be changed in the Demo version)
  '' SG   (integer)  segments, default 22, range [2,4, 6, 8, 22] (Cannot be changed in the Demo version)
  '' Q    (integer)  quietzone, default 1, range [1 .. n] (Cannot be changed in the Demo version)
  
  Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
      Call createBarcode()
  End Sub
  
  Sub createBarcode()
	  
		Dim i As Integer
		Dim DataToEncode as String 
		Dim mHeight as integer 
		Dim mResult as String 
		Dim mZoom as integer  
		Dim mQuietzone as integer  
		Dim mSegments as integer  
		Dim x as integer 
		Dim y as integer 
		Dim k as integer 
		dim mvarFinal(,) As Integer             '' Barcode array to be returned which is readable by VB.
		
		'' LM 2018.12.17 add support for image type PNG and JPEG  
		Dim options As Object()
		Dim imagetype as String
        options = New Object() {"imagetype", "I", 3, "BMP"}	
	
        Dim conf As System.Collections.Generic.Dictionary(Of String, Object)
        conf = New System.Collections.Generic.Dictionary(Of String, Object)
        
		conf.Add(CStr(options(0)), Request.QueryString(CStr(options(1))))
		If CStr(conf(CStr(options(0)))) = "" Then conf(CStr(options(0))) = options(3)
        imagetype = CStr(conf("imagetype"))
		If ((imagetype <> "PNG") AND (imagetype <> "JPG") AND (imagetype <> "JPEG") AND (imagetype <> "BMP") ) Then imagetype = "BMP"
				
		
		
		mHeight = 34
		mSegments = 6
		mZoom = 1
		mQuietzone = 1
        
		mResult = "awawwwwwaaawawaaawwawwwwwwwwaaaawawaaaaawwaaaaawawawwaawawwaaaaawaaawawwwwwaaaaaawwawwawwaaawwwaaaawaaawwwawwwawwwwawaaawwwwwwaaaawawawwaawwwwaaaawwawa" & vbCrLf & _
				  "wawaywywztzwvszxvsuxuwywywywztvxyxutvxvxywzxvxvszwzsyxzwvsytzxzxytvxutuwysutvtvtvwuxuszwutvxywuxzxvszxzwuwzsysvwywutuxvxywywywzxvtyxutywvxususvxztuswaw"
		
		
		Dim xSize as integer 
		Dim ySize as integer 
		Dim c as string 
		Dim xPos as integer 
		Dim yPos as integer 
		Dim RowsToPrint() as string 
		Dim nRow as integer 
		Dim nRows as integer 
		Dim finalWidth as integer 
		Dim finalHeight as integer 
		
		RowsToPrint = Split(mResult, vbCrLf) '' chr(13) & chr(10))
		
		'' find width of bitmap
		xSize = 0
		ySize = 3+mHeight
		nRows = Ubound(RowsToPrint)+1
		
		for i = 1 to len(RowsToPrint(0))
			c = mid(RowsToPrint(0) , i, 1)
			if (c>= "1" and c<="9") then	
				xSize = xSize + cint(val(c))
			else if (c >= "p" and c <= "z") then
				xSize = xSize +1
			else if (c>= "a" and c<= "i") then 
				xSize = xSize + asc(c) - 97 +1
			end if
		next
		
		'' calc final size width and height	
		finalWidth = xSize + 2*mQuietzone
		finalHeight = ySize*nRows + 2*mQuietzone-3 '' remove first 3 lines on first rows, always blank
		'' to resize matrix ()
		ReDim mvarFinal( finalHeight - 1, finalWidth - 1) 

		'' convert string to pixel bars
		yPos = mQuietzone - 3
		for nRow = 0 to nRows - 1
			xPos = mQuietzone
			for i = 1 to len(RowsToPrint(nRow))			
				c = mid(RowsToPrint(nRow) , i, 1)	
				if (c>= "a" and c<= "i") then
					xPos = xPos + asc(c) - 97 +1
				else if	(c>= "1" and c<="9") then
					for x = 1 to cint(val(c))
						for y = 1 to mHeight
							mvarFinal(2+y + yPos, xPos) = 1
						next
						xPos = xPos + 1
					next
				else if	(c>= "w" and c<="z") then			
					for y = 1 to mHeight
						mvarFinal(2+y + yPos, xPos) = 1
					next
					if (c="x") then
						mvarFinal(0 + yPos, xPos) = 1
					else if (c="y") then
						mvarFinal(1 + yPos, xPos) = 1
					else if (c="z") then
						mvarFinal(0 + yPos, xPos) = 1
						mvarFinal(1 + yPos, xPos) = 1
					end if
					xPos = xPos + 1
				else if	(c>= "p" and c<="v") then
					if (c="p") then
						mvarFinal(0 + yPos, xPos) = 1
					else if (c="q") then
						mvarFinal(1 + yPos, xPos) = 1
					else if (c="r") then
						mvarFinal(0 + yPos, xPos) = 1
						mvarFinal(1 + yPos, xPos) = 1
					else if (c="s") then
						mvarFinal(2 + yPos, xPos) = 1
					else if (c="t") then	
						mvarFinal(0 + yPos, xPos) = 1
						mvarFinal(2 + yPos, xPos) = 1	
					else if (c="u") then
						mvarFinal(1 + yPos, xPos) = 1
						mvarFinal(2 + yPos, xPos) = 1
					else if (c="v") then
						mvarFinal(0 + yPos, xPos) = 1
						mvarFinal(1 + yPos, xPos) = 1
						mvarFinal(2 + yPos, xPos) = 1
					end if
					xPos = xPos + 1
				end if	
			next		
			yPos = yPos + ySize
		Next 
		
			'' BMP image with 1 bit color depth
			if (imagetype = "BMP") Then					
				Response.ContentType = "image/bmp"
				Response.BinaryWrite(GetBMP(mvarFinal, finalHeight, finalWidth))  				
			
			Else 
			
				'' LM 2018.12.17 add support for image type PNG and JPEG
				Dim ms As MemoryStream = New MemoryStream
				Dim newimage As New Bitmap(finalWidth, finalHeight)
				Dim gr As Graphics = Graphics.FromImage(newimage)
				Dim blackBrush as New SolidBrush(Color.Black)	
				Dim dotRect as Rectangle

				gr.Clear(Color.White)
				For i = 0 to finalHeight -1
					For k = 0 to finalWidth -1
						if mvarFinal(i,k) = 1 then
							dotRect = new Rectangle(k, i, 1,1)
							gr.FillRectangle(blackBrush, dotRect)
						end if  
					Next
				Next  				
								

				if (imagetype = "PNG") Then
					Response.ContentType = "image/png"
					newimage.Save(ms, System.Drawing.Imaging.ImageFormat.png)				
				elseif (imagetype = "JPEG" OR imagetype = "JPG") Then
					Response.ContentType = "image/jpeg"
					newimage.Save(ms, System.Drawing.Imaging.ImageFormat.jpeg)				
				End if
				
				Dim b() As Byte = ms.ToArray
				response.binarywrite(b)						
			
			End If	         
  End Sub

  '' support functions 
  '' *****************************************************************************

  Private Function size(ByVal length As Double) As String
      length = CDbl(length)
      If length > 255 Then
          If length > 65535 Then length = 65535
          size = Chr(CInt(length Mod 256)) & Chr(CInt(Int(length / 256)))
      Else
          size = Chr(CInt(length)) & Chr(0)
      End If
  End Function


  Private Function val(ByVal str As String) As Long
      val = CLng(regExReplace(str, "\D", ""))
  End Function

  Private Function regExReplace(ByVal str As String, ByVal regex As String, ByVal rep As String) As String
      Dim r As System.Text.RegularExpressions.Regex

      r = New System.Text.RegularExpressions.Regex(regex, System.Text.RegularExpressions.RegexOptions.IgnoreCase)
      regExReplace = r.Replace(str, rep)

      r = Nothing
  End Function

  

  Private Function GetBMP(ByRef Matrix(,) As Integer, ByVal SizeY As Integer, ByVal SizeX As Integer) As Byte()    

    Dim y As Integer
    Dim x As Integer
    Dim k As Integer
    Dim intTemp As Integer
    
    Dim pixels As Integer
    Dim pos As Integer
    
    Dim height As Long
    Dim width As Long
    
    Dim Stream() As Byte
    Dim rowbytes As Long
    Dim xPos As Integer
    Dim i As Long
    Dim intPad As Integer

    height = SizeY 
    width = SizeX 
    
    
    intPad = 0
    intTemp = CInt(((width \ 8) + CInt(IIf(width Mod 8 > 0, 1, 0))) Mod 4)
    If intTemp <> 0 Then intPad = 4 - intTemp
    
    rowbytes = (width \ 8) +  CInt(IIf(width Mod 8 > 0, 1, 0)) + intPad
    ReDim Stream(CInt(rowbytes * height) + 62 - 1)
    
    Stream(0) = 66
    Stream(1) = 77
    Stream(10) = 62
    Stream(14) = 40
    Stream(18) = CByte(width Mod 256)
    Stream(19) = CByte(width \ 256)
    Stream(22) = CByte(height Mod 256)
    Stream(23) = CByte(height \ 256)
    Stream(26) = 1
    Stream(28) = 1
    Stream(38) = 37
    Stream(39) = 14
    Stream(42) = 37
    Stream(43) = 14
    Stream(54) = 255
    Stream(55) = 255
    Stream(56) = 255
    
    xPos = 62
    For y = SizeY - 1 To 0 Step -1 '' for each row
      pixels = 0
      pos = 8
      For x = 0 To SizeX - 1 '' for each column
        pos = pos - 1
        If Matrix(y, x) >= 1 Then pixels = CInt(pixels + 2 ^ pos)
        If pos = 0 Then
          Stream(xPos) = CByte(pixels)
          xPos = xPos + 1
          pos = 8
          pixels = 0
        End If 
      Next
      
      If pos <> 8 Then
        Stream(xPos) = CByte(pixels)
        xPos = xPos + 1
      End If
      xPos = xPos + intPad 
    Next
    
    GetBMP = Stream
  End Function
  
  '' *****************************************************************************


</script>